CodecBase.jl
============

## Installation

```julia
Pkg.add("CodecBase")
```

## Usage

```julia
using CodecBase

# UTF8-encoded text.
data = """
祇園精舎の鐘の声、諸行無常の響きあり。
沙羅双樹の花の色、盛者必衰のことわりをあらはす。
奢れる人も久しからず、唯春の夜の夢のごとし。
"""

# Base64-encoded data of the above.
base64 = """
56WH5ZyS57K+6IiO44Gu6ZCY44Gu5aOw44CB6Ku46KGM54Sh5b
i444Gu6Z+/44GN44GC44KK44CCCuaymee+heWPjOaoueOBruiK
seOBruiJsuOAgeebm+iAheW/heihsOOBruOBk+OBqOOCj+OCiu
OCkuOBguOCieOBr+OBmeOAggrlpaLjgozjgovkurrjgoLkuYXj
gZfjgYvjgonjgZrjgIHllK/mmKXjga7lpJzjga7lpKLjga7jgZ
TjgajjgZfjgIIK
"""

# Streaming API.
encoded = readstring(Base64EncoderStream(IOBuffer(data)))
@assert encoded == replace(base64, "\n", "")
decoded = read(Base64DecoderStream(IOBuffer(base64)))
@assert decoded == Vector{UInt8}(data)

# Byte array API.
encoded = transcode(Base64Encoder(), data)
@assert String(encoded) == replace(base64, "\n", "")
decoded = transcode(Base64Decoder(), base64)
@assert decoded == Vector{UInt8}(data)
```

This package exports following codecs and streams:

| Codec           | Stream                |
| --------------- | --------------------- |
| `Base16Encoder` | `Base16EncoderStream` |
| `Base16Decoder` | `Base16DecoderStream` |
| `Base32Encoder` | `Base32EncoderStream` |
| `Base32Decoder` | `Base32DecoderStream` |
| `Base64Encoder` | `Base64EncoderStream` |
| `Base64Decoder` | `Base64DecoderStream` |

See docstrings and
[TranscodingStreams.jl](https://github.com/bicycle1885/TranscodingStreams.jl)
for details.

[travisci-img]: https://travis-ci.org/bicycle1885/CodecBase.jl.svg?branch=master
[travisci-url]: https://travis-ci.org/bicycle1885/CodecBase.jl
[codecov-img]: http://codecov.io/github/bicycle1885/CodecBase.jl/coverage.svg?branch=master
[codecov-url]: http://codecov.io/github/bicycle1885/CodecBase.jl?branch=master

# Base16 Encoder
# ==============

struct Base16Encoder <: Codec
    table::CodeTable16
    state::State
end

Base16Encoder(table::CodeTable16) = Base16Encoder(table, State())

"""
    Base16Encoder(;lowercase=false)

Create a base16 encoding codec.

Arguments
- `lowercase`: use [0-9a-f] instead of [0-9A-F].
"""
function Base16Encoder(;lowercase::Bool=false)
    if lowercase
        table = BASE16_LOWER
    else
        table = BASE16_UPPER
    end
    return Base16Encoder(table)
end

const Base16EncoderStream{S} = TranscodingStream{Base16Encoder,S} where S<:IO

"""
    Base16EncoderStream(stream::IO; kwargs...)

Create a base16 encoding stream (see `Base16Encoder` for `kwargs`).
"""
function Base16EncoderStream(stream::IO; kwargs...)
    return TranscodingStream(Base16Encoder(;kwargs...), stream)
end

macro encode16(i, j1, j2)
    quote
        a = input[$(i)]
        output[$(j1)] = encode(table, a >> 4)
        output[$(j2)] = encode(table, a & 0x0f)
    end |> esc
end

function TranscodingStreams.startproc(
        codec :: Base16Encoder,
        state :: Symbol,
        error :: Error)
    start!(codec.state)
    return :ok
end

function TranscodingStreams.process(
        codec  :: Base16Encoder,
        input  :: Memory,
        output :: Memory,
        error  :: Error)
    table = codec.table
    state = codec.state

    # Check if we can encode data.
    if !is_running(state)
        error[] = ArgumentError("encoding is already finished")
        return 0, 0, :error
    elseif input.size == 0
        finish!(state)
        return 0, 0, :end
    elseif output.size < 2
        # Need more output space.
        return 0, 0, :ok
    end

    # Encode the data.
    i = j = 0
    k::Int = min(fld(input.size, 4), fld(output.size, 8))
    @inbounds while k > 0  # ≡ i + 4 ≤ input.size && j + 8 ≤ output.size
        # unrolled loop
        @encode16 i+1 j+1 j+2
        @encode16 i+2 j+3 j+4
        @encode16 i+3 j+5 j+6
        @encode16 i+4 j+7 j+8
        i += 4
        j += 8
        k -= 1
    end
    @inbounds while i + 1 ≤ input.size && j + 2 ≤ output.size
        @encode16 i+1 j+1 j+2
        i += 1
        j += 2
    end
    return i, j, :ok
end

# CodeTable
# =========

struct CodeTable{base}
    # n-bit code => ascii code
    encodeword::Vector{UInt8}

    # ascii code => n-bit code
    decodeword::Vector{UInt8}

    # ascii code for padding
    padcode::UInt8
end

function Base.copy(table::CodeTable{base}) where base
    return CodeTable{base}(
        copy(table.encodeword),
        copy(table.decodeword),
        table.padcode)
end

const whitespace = "\t\n\v\f\r "

function ignorecode end

"""
    ignorechars!(table::CodeTable, asciichars::String)

Add characters that will be ignored while decoding.
"""
function ignorechars!(table::CodeTable, asciichars::String)
    if !isascii(asciichars)
        throw(ArgumentError("ignored characters must be ASCII"))
    end
    for char in asciichars
        code = UInt8(char)
        table.decodeword[code+1] = ignorecode(typeof(table))
    end
    return table
end

# CodeTable16
# ===========

const CodeTable16 = CodeTable{16}

const BASE16_CODEIGN = 0x10  # IGNore
const BASE16_CODEEND = 0x11  # END
const BASE16_CODEERR = 0xff  # ERRor

ignorecode(::Type{CodeTable16}) = BASE16_CODEIGN

"""
    CodeTable16(asciicode:::String; casesensitive::Bool=false)

Create a code table for base16.
"""
function CodeTable16(asciicode::String; casesensitive::Bool=false)
    if !isascii(asciicode)
        throw(ArgumentError("the code table must be ASCII"))
    elseif length(asciicode) != 16
        throw(ArgumentError("the code size must be 16"))
    end
    encodeword = Vector{UInt8}(undef, 16)
    decodeword = Vector{UInt8}(undef, 256)
    fill!(decodeword, BASE16_CODEERR)
    for (i, char) in enumerate(asciicode)
        bits = UInt8(i-1)
        code = UInt8(char)
        encodeword[bits+1] = code
        decodeword[code+1] = bits
        if !casesensitive
            if isuppercase(char)
                code = UInt8(lowercase(char))
                decodeword[code+1] = bits
            end
            if islowercase(char)
                code = UInt8(uppercase(char))
                decodeword[code+1] = bits
            end
        end
    end
    # NOTE: The padcode is not used.
    return CodeTable16(encodeword, decodeword, 0x00)
end

@inline function encode(table::CodeTable16, x::UInt8)
    return table.encodeword[Int(x)+1]
end

@inline function decode(table::CodeTable16, x::UInt8)
    return table.decodeword[Int(x)+1]
end

"""
The hexadecimal base16 code table (encoding: uppercase; decoding: case-insensitive).
"""
const BASE16_UPPER = CodeTable16("0123456789ABCDEF")

"""
The hexadecimal base16 code table (encoding: lowercase; decoding: case-insensitive).
"""
const BASE16_LOWER = CodeTable16("0123456789abcdef")

# Base32 Encoder
# ==============

struct Base32Encoder <: Codec
    table::CodeTable32
    state::State
    buffer::Buffer
end

Base32Encoder(table::CodeTable32) = Base32Encoder(table, State(), Buffer(4))

"""
    Base32Encoder(;hex::Bool=false)

Create a base32 encoding codec.

Arguments
---------
- `hex`: use extended hex alphabet (Table 4 of RFC4648)
"""
function Base32Encoder(;hex::Bool=false)
    if hex
        table = BASE32_HEX
    else
        table = BASE32_STD
    end
    return Base32Encoder(table)
end

const Base32EncoderStream{S} = TranscodingStream{Base32Encoder,S} where S<:IO

"""
    Base32EncoderStream(stream::IO; kwargs...)

Create a base32 encoding stream (see `Base32Encoder` for `kwargs`).
"""
function Base32EncoderStream(stream::IO; kwargs...)
    return TranscodingStream(Base32Encoder(;kwargs...), stream)
end

function TranscodingStreams.startproc(
        codec :: Base32Encoder,
        state :: Symbol,
        error :: Error)
    start!(codec.state)
    empty!(codec.buffer)
    return :ok
end

function TranscodingStreams.process(
        codec  :: Base32Encoder,
        input  :: Memory,
        output :: Memory,
        error  :: Error)
    table = codec.table
    state = codec.state
    buffer = codec.buffer

    # Check if we can encode data.
    if !is_running(state)
        error[] = ArgumentError("encoding is already finished")
        return 0, 0, :error
    elseif output.size < 8
        # Need more output space.
        return 0, 0, :ok
    end

    # Load the first five bytes.
    i = j = 0
    while buffer.size < 4 && i < input.size
        buffer[buffer.size+=1] = input[i+=1]
    end
    b1 = b2 = b3 = b4 = b5 = 0x00
    npad = 0
    status = :ok
    if i < input.size
        b1 = buffer[1]
        b2 = buffer[2]
        b3 = buffer[3]
        b4 = buffer[4]
        b5 = input[i+=1]
    elseif input.size == 0
        # Found the end of the input.
        if buffer.size == 0
            finish!(state)
            return i, j, :end
        elseif buffer.size == 1
            b1 = buffer[1]
            npad = 6
        elseif buffer.size == 2
            b1 = buffer[1]
            b2 = buffer[2]
            npad = 4
        elseif buffer.size == 3
            b1 = buffer[1]
            b2 = buffer[2]
            b3 = buffer[3]
            npad = 3
        elseif buffer.size == 4
            b1 = buffer[1]
            b2 = buffer[2]
            b3 = buffer[3]
            b4 = buffer[4]
            npad = 1
        else
            @unreachable
        end
        status = :end
    else
        # Need more data to encode.
        return i, j, :ok
    end
    empty!(buffer)

    # Encode the body.
    #  01234567 89012345 67890123 45678901 23456789
    # +--------+--------+--------+--------+--------+
    # |< 1 >< 2| >< 3 ><| 4 >< 5 |>< 6 >< |7 >< 8 >|
    # +--------+--------+--------+--------+--------+
    @inbounds while true
        output[j+1] = encode(table, b1 >> 3)
        output[j+2] = encode(table, b1 << 2 | b2 >> 6)
        output[j+3] = encode(table, b2 >> 1)
        output[j+4] = encode(table, b2 << 4 | b3 >> 4)
        output[j+5] = encode(table, b3 << 1 | b4 >> 7)
        output[j+6] = encode(table, b4 >> 2)
        output[j+7] = encode(table, b4 << 3 | b5 >> 5)
        output[j+8] = encode(table, b5)
        j += 8
        if i + 5 ≤ input.size && j + 8 ≤ output.size
            b1 = input[i+1]
            b2 = input[i+2]
            b3 = input[i+3]
            b4 = input[i+4]
            b5 = input[i+5]
            i += 5
        else
            break
        end
    end

    # Epilogue.
    while npad > 0
        output[j-npad+1] = table.padcode
        npad -= 1
    end
    if status == :end || status == :error
        finish!(state)
    end
    return i, j, status
end

# Base64 Decoder
# ==============

struct Base64Decoder <: Codec
    table::CodeTable64
    state::State
    buffer::Buffer
end

Base64Decoder(table::CodeTable64) = Base64Decoder(table, State(), Buffer(3))

"""
    Base64Decoder(;urlsafe::Bool=false, ignore::String="$(escape_string(whitespace))")

Create a base64 decoding codec.

Arguments
---------
- `urlsafe`: use `-` and `_` as the last two values
- `ignore`: ASCII characters that will be ignored while decoding
"""
function Base64Decoder(;urlsafe::Bool=false, ignore::String=whitespace)
    if urlsafe
        table = BASE64_URLSAFE
    else
        table = BASE64_STD
    end
    table = copy(table)
    ignorechars!(table, ignore)
    return Base64Decoder(table)
end

const Base64DecoderStream{S} = TranscodingStream{Base64Decoder,S} where S<:IO

"""
    Base64DecoderStream(stream::IO; kwargs...)

Create a base64 decoding stream (see `Base64Decoder` for `kwargs`).
"""
function Base64DecoderStream(stream::IO; kwargs...)
    return TranscodingStream(Base64Decoder(;kwargs...), stream)
end

function TranscodingStreams.startproc(
        codec :: Base64Decoder,
        state :: Symbol,
        error :: Error)
    start!(codec.state)
    return :ok
end

function TranscodingStreams.process(
        codec  :: Base64Decoder,
        input  :: Memory,
        output :: Memory,
        error  :: Error)
    table = codec.table
    state = codec.state
    buffer = codec.buffer

    # Check if we can encode data.
    if !is_running(state)
        error[] = ArgumentError("decoding is already finished")
        return 0, 0, :error
    elseif output.size < 3
        # Need more output space.
        return 0, 0, :ok
    end

    # Load the first bytes.
    i = j = 0
    while buffer.size < 3 && i < input.size
        buffer[buffer.size+=1] = input[i+=1]
    end
    c1 = c2 = c3 = c4 = BASE64_CODEIGN
    if buffer.size ≥ 1
        c1 = decode(table, buffer[1])
    end
    if buffer.size ≥ 2
        c2 = decode(table, buffer[2])
    end
    if buffer.size ≥ 3
        c3 = decode(table, buffer[3])
    end
    empty!(buffer)

    # Start decoding loop.
    status = :ok
    @inbounds while true
        if c1 > 0x3f || c2 > 0x3f || c3 > 0x3f || c4 > 0x3f
            i, j, status = decode64_irregular(table, c1, c2, c3, c4, input, i, output, j, error)
        else
            output[j+1] = c1 << 2 | c2 >> 4
            output[j+2] = c2 << 4 | c3 >> 2
            output[j+3] = c3 << 6 | c4
            j += 3
        end
        if i + 4 ≤ input.size && j + 3 ≤ output.size && status == :ok
            c1 = decode(table, input[i+1])
            c2 = decode(table, input[i+2])
            c3 = decode(table, input[i+3])
            c4 = decode(table, input[i+4])
            i += 4
        else
            break
        end
    end

    # Epilogue.
    if status == :end || status == :error
        finish!(state)
    end
    return i, j, status
end

# Decode irregular code (e.g. non-alphabet, padding, etc.).
function decode64_irregular(table, c1, c2, c3, c4, input, i, output, j, error)
    # Skip ignored chars.
    while true
        if c1 == BASE64_CODEIGN
            c1, c2, c3 = c2, c3, c4
        elseif c2 == BASE64_CODEIGN
            c2, c3 = c3, c4
        elseif c3 == BASE64_CODEIGN
            c3 = c4
        elseif c4 == BASE64_CODEIGN
            # pass
        else
            break
        end
        if i + 1 ≤ input.size
            c4 = decode(table, input[i+=1])
        else
            c4 = BASE64_CODEEND
            break
        end
    end

    # Write output.
    if c1 ≤ 0x3f && c2 ≤ 0x3f && c3 ≤ 0x3f && c4 ≤ 0x3f
        output[j+=1] = c1 << 2 | c2 >> 4
        output[j+=1] = c2 << 4 | c3 >> 2
        output[j+=1] = c3 << 6 | c4
        status = :ok
    elseif c1 ≤ 0x3f && c2 ≤ 0x3f && c3 ≤ 0x3f && c4 == BASE64_CODEPAD
        c4 = 0x00
        output[j+=1] = c1 << 2 | c2 >> 4
        output[j+=1] = c2 << 4 | c3 >> 2
        status = :end
    elseif c1 ≤ 0x3f && c2 ≤ 0x3f && c3 == c4 == BASE64_CODEPAD
        c3 = c4 = 0x00
        output[j+=1] = c1 << 2 | c2 >> 4
        status = :end
    elseif c1 == c2 == c3 == BASE64_CODEIGN && c4 == BASE64_CODEEND
        status = :end
    else
        error[] = DecodeError("invalid base64 data")
        status = :error
    end
    return i, j, status
end

# Base32 Decoder
# ==============

struct Base32Decoder <: Codec
    table::CodeTable32
    state::State
    buffer::Buffer
end

Base32Decoder(table::CodeTable32) = Base32Decoder(table, State(), Buffer(7))

"""
    Base32Decoder(;hex::Bool=false, ignore::String=$(escape_string(whitespace)))

Create a base32 decoding codec.

Arguments
---------
- `hex`: use extended hex alphabet (Table 4 of RFC4648)
- `ignore`: ASCII characters that will be ignored while decoding
"""
function Base32Decoder(;hex::Bool=false, ignore::String=whitespace)
    if hex
        table = BASE32_HEX
    else
        table = BASE32_STD
    end
    table = copy(table)
    ignorechars!(table, ignore)
    return Base32Decoder(table)
end

const Base32DecoderStream{S} = TranscodingStream{Base32Decoder,S} where S<:IO

"""
    Base32DecoderStream(stream::IO; kwargs...)

Create a base32 decoding stream (see `Base32Decoder` for `kwargs`).
"""
function Base32DecoderStream(stream::IO; kwargs...)
    return TranscodingStream(Base32Decoder(;kwargs...), stream)
end

function TranscodingStreams.startproc(
        codec :: Base32Decoder,
        state :: Symbol,
        error :: Error)
    start!(codec.state)
    return :ok
end

function TranscodingStreams.process(
        codec  :: Base32Decoder,
        input  :: Memory,
        output :: Memory,
        error  :: Error)
    table = codec.table
    state = codec.state
    buffer = codec.buffer

    # Check if we can encode data.
    if !is_running(state)
        error[] = ArgumentError("decoding is already finished")
        return 0, 0, :error
    elseif output.size < 3
        # Need more output space.
        return 0, 0, :ok
    end

    # Load the first bytes.
    i = j = 0
    while buffer.size < 7 && i + 1 ≤ input.size
        buffer[buffer.size+=1] = input[i+=1]
    end
    c1 = c2 = c3 = c4 = c5 = c6 = c7 = c8 = BASE32_CODEIGN
    if buffer.size ≥ 1
        c1 = decode(table, buffer[1])
    end
    if buffer.size ≥ 2
        c2 = decode(table, buffer[2])
    end
    if buffer.size ≥ 3
        c3 = decode(table, buffer[3])
    end
    if buffer.size ≥ 4
        c4 = decode(table, buffer[4])
    end
    if buffer.size ≥ 5
        c5 = decode(table, buffer[5])
    end
    if buffer.size ≥ 6
        c6 = decode(table, buffer[6])
    end
    if buffer.size ≥ 7
        c7 = decode(table, buffer[7])
    end
    empty!(buffer)

    # Start decoding loop.
    #  01234567 89012345 67890123 45678901 23456789
    # +--------+--------+--------+--------+--------+
    # |< 1 >< 2| >< 3 ><| 4 >< 5 |>< 6 >< |7 >< 8 >|
    # +--------+--------+--------+--------+--------+
    status = :ok
    @inbounds while true
        if c1 > 0x1f || c2 > 0x1f || c3 > 0x1f || c4 > 0x1f ||
           c5 > 0x1f || c6 > 0x1f || c7 > 0x1f || c8 > 0x1f
           i, j, status = decode32_irregular(
               table,
               c1, c2, c3, c4, c5, c6, c7, c8,
               input,  i,
               output, j,
               error)
        else
            output[j+1] = c1 << 3 | c2 >> 2
            output[j+2] = c2 << 6 | c3 << 1 | c4 >> 4
            output[j+3] = c4 << 4 | c5 >> 1
            output[j+4] = c5 << 7 | c6 << 2 | c7 >> 3
            output[j+5] = c7 << 5 | c8
            j += 5
        end
        if i + 8 ≤ input.size && j + 5 ≤ output.size && status == :ok
            c1 = decode(table, input[i+1])
            c2 = decode(table, input[i+2])
            c3 = decode(table, input[i+3])
            c4 = decode(table, input[i+4])
            c5 = decode(table, input[i+5])
            c6 = decode(table, input[i+6])
            c7 = decode(table, input[i+7])
            c8 = decode(table, input[i+8])
            i += 8
        else
            break
        end
    end

    # Epilogue.
    if status == :end || status == :error
        finish!(state)
    end
    return i, j, status
end

function decode32_irregular(table, c1, c2, c3, c4, c5, c6, c7, c8, input, i, output, j, error)
    # Skip ignored chars.
    while true
        if c1 == BASE32_CODEIGN
            c1, c2, c3, c4, c5, c6, c7 = c2, c3, c4, c5, c6, c7, c8
        elseif c2 == BASE32_CODEIGN
            c2, c3, c4, c5, c6, c7 = c3, c4, c5, c6, c7, c8
        elseif c3 == BASE32_CODEIGN
            c3, c4, c5, c6, c7 = c4, c5, c6, c7, c8
        elseif c4 == BASE32_CODEIGN
            c4, c5, c6, c7 = c5, c6, c7, c8
        elseif c5 == BASE32_CODEIGN
            c5, c6, c7 = c6, c7, c8
        elseif c6 == BASE32_CODEIGN
            c6, c7 = c7, c8
        elseif c7 == BASE32_CODEIGN
            c7 = c8
        elseif c8 == BASE32_CODEIGN
            # pass
        else
            break
        end
        if i + 1 ≤ input.size
            c8 = decode(table, input[i+=1])
        else
            c8 = BASE32_CODEEND
            break
        end
    end

    # Write output.
    if max(c1, c2, c3, c4, c5, c6, c7, c8) ≤ 0x1f
        output[j+=1] = c1 << 3 | c2 >> 2
        output[j+=1] = c2 << 6 | c3 << 1 | c4 >> 4
        output[j+=1] = c4 << 4 | c5 >> 1
        output[j+=1] = c5 << 7 | c6 << 2 | c7 >> 3
        output[j+=1] = c7 << 5 | c8
        status = :ok
    elseif max(c1, c2, c3, c4, c5, c6, c7) ≤ 0x1f && c8 == BASE32_CODEPAD
        output[j+=1] = c1 << 3 | c2 >> 2
        output[j+=1] = c2 << 6 | c3 << 1 | c4 >> 4
        output[j+=1] = c4 << 4 | c5 >> 1
        output[j+=1] = c5 << 7 | c6 << 2 | c7 >> 3
        status = :end
    elseif max(c1, c2, c3, c4, c5) ≤ 0x1f && c6 == c7 == c8 == BASE32_CODEPAD
        output[j+=1] = c1 << 3 | c2 >> 2
        output[j+=1] = c2 << 6 | c3 << 1 | c4 >> 4
        output[j+=1] = c4 << 4 | c5 >> 1
        status = :end
    elseif max(c1, c2, c3, c4) ≤ 0x1f && c5 == c6 == c7 == c8 == BASE32_CODEPAD
        output[j+=1] = c1 << 3 | c2 >> 2
        output[j+=1] = c2 << 6 | c3 << 1 | c4 >> 4
        status = :end
    elseif max(c1, c2) ≤ 0x1f && c3 == c4 == c5 == c6 == c7 == c8 == BASE32_CODEPAD
        output[j+=1] = c1 << 3 | c2 >> 2
        status = :end
    elseif c1 == c2 == c3 == c4 == c5 == c6 == c7 == BASE32_CODEIGN && c8 == BASE32_CODEEND
        status = :end
    else
        error[] = DecodeError("invalid base32 data")
        status = :error
    end

    return i, j, status
end

using CodecBase
using BenchmarkTools

# Make data.
data_bin = read(joinpath(@__DIR__, "data.bin"))
data16 = transcode(Base16Encoder(), data_bin)
data32 = transcode(Base32Encoder(), data_bin)
data64 = transcode(Base64Encoder(), data_bin)

# Define benchmarks.
suite = BenchmarkGroup()
suite["Base16"] = BenchmarkGroup()
suite["Base16"]["Encoder"] = @benchmarkable transcode(Base16Encoder(), data_bin)
suite["Base16"]["Decoder"] = @benchmarkable transcode(Base16Decoder(), data16)
suite["Base32"] = BenchmarkGroup()
suite["Base32"]["Encoder"] = @benchmarkable transcode(Base32Encoder(), data_bin)
suite["Base32"]["Decoder"] = @benchmarkable transcode(Base32Decoder(), data32)
suite["Base64"] = BenchmarkGroup()
suite["Base64"]["Encoder"] = @benchmarkable transcode(Base64Encoder(), data_bin)
suite["Base64"]["Decoder"] = @benchmarkable transcode(Base64Decoder(), data64)

# Run benchmarks and print the results.
tune!(suite)
results = run(suite, verbose=true, seconds=1)
for k1 in ["Base16", "Base32", "Base64"]
    for k2 in ["Encoder", "Decoder"]
        println("--- $(k1) $(k2) ---")
        show(STDOUT, MIME"text/plain"(), results[k1][k2])
        println()
        println()
    end
end

# State
# =====

mutable struct State
    state::Symbol
    State() = new(:init)
end

function start!(state::State)
    state.state = :running
end

function finish!(state::State)
    state.state = :finished
end

function is_running(state::State)
    return state.state == :running
end

using CodecBase
using Test
using TranscodingStreams:
    TranscodingStreams,
    TranscodingStream
using TestsForCodecPackages:
    test_roundtrip_read,
    test_roundtrip_write,
    test_roundtrip_lines,
    test_roundtrip_seekstart,
    test_roundtrip_transcode

@testset "DecodeError" begin
    error = CodecBase.DecodeError("basexx: invalid data")
    @test error isa CodecBase.DecodeError
    @test error isa Exception
    @test sprint(showerror, error) == "DecodeError: basexx: invalid data"
    try
        throw(error)
        @test false
    catch ex
        @test ex isa CodecBase.DecodeError
    end
end

@testset "Base16" begin
    CodeTable16 = CodecBase.CodeTable16
    @test_throws ArgumentError CodeTable16("Sigur Rós")
    @test_throws ArgumentError CodeTable16("Takk")
    table = copy(CodecBase.BASE16_UPPER)
    @test_throws ArgumentError CodecBase.ignorechars!(table, "Jónsi")

    @test transcode(Base16Encoder(), b"") == b""
    @test transcode(Base16Encoder(), b"f") == b"66"
    @test transcode(Base16Encoder(), b"fo") == b"666F"
    @test transcode(Base16Encoder(), b"foo") == b"666F6F"
    @test transcode(Base16Encoder(), b"foob") == b"666F6F62"
    @test transcode(Base16Encoder(), b"fooba") == b"666F6F6261"
    @test transcode(Base16Encoder(), b"foobar") == b"666F6F626172"

    @test transcode(Base16Encoder(lowercase=false), b"自問自答") == b"E887AAE5958FE887AAE7AD94"
    @test transcode(Base16Encoder(lowercase=true),  b"自問自答") == b"e887aae5958fe887aae7ad94"

    @test transcode(Base16Decoder(), b"") == b""
    @test transcode(Base16Decoder(), b"66") == b"f"
    @test transcode(Base16Decoder(), b"666F") == b"fo"
    @test transcode(Base16Decoder(), b"666F6F") == b"foo"
    @test transcode(Base16Decoder(), b"666F6F62") == b"foob"
    @test transcode(Base16Decoder(), b"666F6F6261") == b"fooba"
    @test transcode(Base16Decoder(), b"666F6F626172") == b"foobar"
    @test transcode(Base16Decoder(), b"666f6F626172") == b"foobar"

    @test transcode(Base16Decoder(), b"   ") == b""
    @test transcode(Base16Decoder(), b"666\nF6F") == b"foo"
    @test transcode(Base16Decoder(), b"666\r\nF6F") == b"foo"
    @test transcode(Base16Decoder(), b"6  66\r\nF6F   ") == b"foo"
    @test transcode(Base16Decoder(), b"  66\t6F\t6F\n") == b"foo"

    DecodeError = CodecBase.DecodeError
    @test_throws DecodeError transcode(Base16Decoder(), b"a")
    @test_throws DecodeError transcode(Base16Decoder(), b"aaa")
    @test_throws DecodeError transcode(Base16Decoder(), b"aaaaa")
    @test_throws DecodeError transcode(Base16Decoder(), b"\0")
    @test_throws DecodeError transcode(Base16Decoder(), b"a\0")
    @test_throws DecodeError transcode(Base16Decoder(), b"aa\0")
    @test_throws DecodeError transcode(Base16Decoder(), b"aaa\0")

    test_roundtrip_read(Base16EncoderStream, Base16DecoderStream)
    test_roundtrip_write(Base16EncoderStream, Base16DecoderStream)
    test_roundtrip_lines(Base16EncoderStream, Base16DecoderStream)
    test_roundtrip_seekstart(Base16EncoderStream, Base16DecoderStream)
    test_roundtrip_transcode(Base16Encoder, Base16Decoder)
end

@testset "Base32" begin
    CodeTable32 = CodecBase.CodeTable32
    @test_throws ArgumentError CodeTable32("Sigur Rós", '=')
    @test_throws ArgumentError CodeTable32("Takk", '=')

    # standard
    @test transcode(Base32Encoder(), b"") == b""
    @test transcode(Base32Encoder(), b"f") == b"MY======"
    @test transcode(Base32Encoder(), b"fo") == b"MZXQ===="
    @test transcode(Base32Encoder(), b"foo") == b"MZXW6==="
    @test transcode(Base32Encoder(), b"foob") == b"MZXW6YQ="
    @test transcode(Base32Encoder(), b"fooba") == b"MZXW6YTB"
    @test transcode(Base32Encoder(), b"foobar") == b"MZXW6YTBOI======"

    @test transcode(Base32Decoder(), b"") == b""
    @test transcode(Base32Decoder(), b"MY======") == b"f"
    @test transcode(Base32Decoder(), b"MZXQ====") == b"fo"
    @test transcode(Base32Decoder(), b"MZXW6===") == b"foo"
    @test transcode(Base32Decoder(), b"MZXW6YQ=") == b"foob"
    @test transcode(Base32Decoder(), b"MZXW6YTB") == b"fooba"
    @test transcode(Base32Decoder(), b"MZXW6YTBOI======") == b"foobar"

    DecodeError = CodecBase.DecodeError
    @test_throws DecodeError transcode(Base32Decoder(), b"MZXW6=")
    @test_throws DecodeError transcode(Base32Decoder(), b"MZXW6==")
    @test_throws DecodeError transcode(Base32Decoder(), b"MZX\0W6===")
    @test_throws DecodeError transcode(Base32Decoder(), b"MZXW6===\0")

    # extended hex
    @test transcode(Base32Encoder(hex=true), b"") == b""
    @test transcode(Base32Encoder(hex=true), b"f") == b"CO======"
    @test transcode(Base32Encoder(hex=true), b"fo") == b"CPNG===="
    @test transcode(Base32Encoder(hex=true), b"foo") == b"CPNMU==="
    @test transcode(Base32Encoder(hex=true), b"foob") == b"CPNMUOG="
    @test transcode(Base32Encoder(hex=true), b"fooba") == b"CPNMUOJ1"
    @test transcode(Base32Encoder(hex=true), b"foobar") == b"CPNMUOJ1E8======"

    @test transcode(Base32Decoder(hex=true), b"") == b""
    @test transcode(Base32Decoder(hex=true), b"CO======") == b"f"
    @test transcode(Base32Decoder(hex=true), b"CPNG====") == b"fo"
    @test transcode(Base32Decoder(hex=true), b"CPNMU===") == b"foo"
    @test transcode(Base32Decoder(hex=true), b"CPNMUOG=") == b"foob"
    @test transcode(Base32Decoder(hex=true), b"CPNMUOJ1") == b"fooba"
    @test transcode(Base32Decoder(hex=true), b"CPNMUOJ1E8======") == b"foobar"

    test_roundtrip_read(Base32EncoderStream, Base32DecoderStream)
    test_roundtrip_write(Base32EncoderStream, Base32DecoderStream)
    test_roundtrip_lines(Base32EncoderStream, Base32DecoderStream)
    test_roundtrip_seekstart(Base32EncoderStream, Base32DecoderStream)
    test_roundtrip_transcode(Base32Encoder, Base32Decoder)
end

@testset "Base64" begin
    CodeTable64 = CodecBase.CodeTable64
    @test_throws ArgumentError CodeTable64("Sigur Rós", '=')
    @test_throws ArgumentError CodeTable64("Takk", '=')

    @test transcode(Base64Encoder(), b"") == b""
    @test transcode(Base64Encoder(), b"f") == b"Zg=="
    @test transcode(Base64Encoder(), b"fo") == b"Zm8="
    @test transcode(Base64Encoder(), b"foo") == b"Zm9v"
    @test transcode(Base64Encoder(), b"foob") == b"Zm9vYg=="
    @test transcode(Base64Encoder(), b"fooba") == b"Zm9vYmE="
    @test transcode(Base64Encoder(), b"foobar") == b"Zm9vYmFy"

    @test transcode(Base64Encoder(urlsafe=false), b"響き") == b"6Z+/44GN"
    @test transcode(Base64Encoder(urlsafe=true),  b"響き") == b"6Z-_44GN"

    @test transcode(Base64Decoder(), b"") == b""
    @test transcode(Base64Decoder(), b"Zg==") == b"f"
    @test transcode(Base64Decoder(), b"Zm8=") == b"fo"
    @test transcode(Base64Decoder(), b"Zm9v") == b"foo"
    @test transcode(Base64Decoder(), b"Zm9vYg==") == b"foob"
    @test transcode(Base64Decoder(), b"Zm9vYmE=") == b"fooba"
    @test transcode(Base64Decoder(), b"Zm9vYmFy") == b"foobar"

    @test transcode(Base64Decoder(), b"Zg=\n=") == b"f"
    @test transcode(Base64Decoder(), b"Zm9v\nYmFy") == b"foobar"
    @test transcode(Base64Decoder(), b"Zg=\r\n=") == b"f"
    @test transcode(Base64Decoder(), b"Z m  9\rv\r\nYm\nF\t\ty") == b"foobar"
    @test transcode(Base64Decoder(), b"  Zm9vYmFy  ") == b"foobar"
    @test transcode(Base64Decoder(), b"      Zm     9v      Ym    Fy      ") == b"foobar"

    @test transcode(Base64Decoder(urlsafe=false), b"6Z+/44GN") == b"響き"
    @test transcode(Base64Decoder(urlsafe=true),  b"6Z-_44GN") == b"響き"

    DecodeError = CodecBase.DecodeError
    @test_throws DecodeError transcode(Base64Decoder(), b"a")
    @test_throws DecodeError transcode(Base64Decoder(), b"aa")
    @test_throws DecodeError transcode(Base64Decoder(), b"aaa")
    @test_throws DecodeError transcode(Base64Decoder(), b"aaaaa")
    @test_throws DecodeError transcode(Base64Decoder(), b"\0")
    @test_throws DecodeError transcode(Base64Decoder(), b"a\0")
    @test_throws DecodeError transcode(Base64Decoder(), b"aa\0")
    @test_throws DecodeError transcode(Base64Decoder(), b"aaa\0")

    test_roundtrip_read(Base64EncoderStream, Base64DecoderStream)
    test_roundtrip_write(Base64EncoderStream, Base64DecoderStream)
    test_roundtrip_lines(Base64EncoderStream, Base64DecoderStream)
    test_roundtrip_seekstart(Base64EncoderStream, Base64DecoderStream)
    test_roundtrip_transcode(Base64Encoder, Base64Decoder)
end

module CodecBase

export
    # base 16
    Base16Encoder,
    Base16EncoderStream,
    Base16Decoder,
    Base16DecoderStream,

    # base 32
    Base32Encoder,
    Base32EncoderStream,
    Base32Decoder,
    Base32DecoderStream,

    # base 64
    Base64Encoder,
    Base64EncoderStream,
    Base64Decoder,
    Base64DecoderStream

import TranscodingStreams:
    TranscodingStreams,
    TranscodingStream,
    Codec,
    Memory,
    Error

macro unreachable()
    :(@assert false "unreachable")
end

include("error.jl")
include("state.jl")
include("buffer.jl")
include("codetable.jl")
include("base16/codetable.jl")
include("base16/encoder.jl")
include("base16/decoder.jl")
include("base32/codetable.jl")
include("base32/encoder.jl")
include("base32/decoder.jl")
include("base64/codetable.jl")
include("base64/encoder.jl")
include("base64/decoder.jl")

end # module

# Base16 Decoder
# ==============

struct Base16Decoder <: Codec
    table::CodeTable16
    state::State
    buffer::Buffer
end

Base16Decoder(table::CodeTable16) = Base16Decoder(table, State(), Buffer(1))

"""
    Base16Decoder(;ignore::String=$(escape_string(whitespace)))

Create a base16 decoding codec.

Arguments
---------
- `ignore`: ASCII characters that will be ignored while decoding
"""
function Base16Decoder(;ignore::String=whitespace)
    table = copy(BASE16_UPPER)
    ignorechars!(table, ignore)
    return Base16Decoder(table)
end

const Base16DecoderStream{S} = TranscodingStream{Base16Decoder,S} where S<:IO

"""
    Base16DecoderStream(stream::IO; kwargs...)

Create a base16 decoding stream (see `Base16Decoder` for `kwargs`).
"""
function Base16DecoderStream(stream::IO; kwargs...)
    return TranscodingStream(Base16Decoder(;kwargs...), stream)
end

function TranscodingStreams.startproc(
        codec :: Base16Decoder,
        state :: Symbol,
        error :: Error)
    start!(codec.state)
    empty!(codec.buffer)
    return :ok
end

function TranscodingStreams.process(
        codec  :: Base16Decoder,
        input  :: Memory,
        output :: Memory,
        error  :: Error)
    table = codec.table
    state = codec.state
    buffer = codec.buffer

    # Check if we can encode data.
    if !is_running(state)
        error[] = ArgumentError("decoding is already finished")
        return 0, 0, :error
    elseif output.size < 1
        # Need more output space.
        return 0, 0, :ok
    end

    # Load the first bytes.
    i = j = 0
    if buffer.size < 1 && i < input.size
        buffer[buffer.size+=1] = input[i+=1]
    end
    c1 = c2 = BASE16_CODEIGN
    if buffer.size ≥ 1
        c1 = decode(table, buffer[1])
    end
    empty!(buffer)

    # Start decoding loop.
    status = :ok
    @inbounds while true
        if c1 > 0x0f || c2 > 0x0f
            i, j, status = decode16_irregular(table, c1, c2, input, i, output, j, error)
        else
            output[j+1] = c1 << 4 | c2
            j += 1
        end
        if i + 2 ≤ input.size && j + 1 ≤ output.size
            c1 = decode(table, input[i+1])
            c2 = decode(table, input[i+2])
            i += 2
        else
            break
        end
    end

    # Epilogue.
    if status == :end || status == :error
        finish!(state)
    end
    return i, j, status
end

# Decode irregular code (e.g. non-alphabet, etc.).
function decode16_irregular(table, c1, c2, input, i, output, j, error)
    # Skip ignored chars.
    while true
        if c1 == BASE16_CODEIGN
            c1 = c2
        elseif c2 == BASE16_CODEIGN
            # pass
        else
            break
        end
        if i + 1 ≤ input.size
            c2 = decode(table, input[i+=1])
        else
            c2 = BASE16_CODEEND
            break
        end
    end

    # Write output.
    if c1 ≤ 0x0f && c2 ≤ 0x0f
        output[j+=1] = c1 << 4 | c2
        status = :ok
    elseif c1 == BASE16_CODEIGN && c2 == BASE16_CODEEND
        status = :end
    else
        error[] = DecodeError("invalid base16 data")
        status = :error
    end
    return i, j, status
end

# Buffer
# ======

mutable struct Buffer
    data::Vector{UInt8}
    size::Int
end

Buffer(bufsize) = Buffer(Vector{UInt8}(undef, bufsize), 0)
Base.empty!(buffer::Buffer) = buffer.size = 0
Base.getindex(buffer::Buffer, i::Integer) = getindex(buffer.data, i)
Base.setindex!(buffer::Buffer, v, i::Integer) = setindex!(buffer.data, v, i)

# CodeTable32
# ===========

const CodeTable32 = CodeTable{32}

const BASE32_CODEPAD = 0x20  # PADding
const BASE32_CODEIGN = 0x21  # IGNore
const BASE32_CODEEND = 0x22  # END
const BASE32_CODEERR = 0xff  # ERRor

ignorecode(::Type{CodeTable32}) = BASE32_CODEIGN

"""
    CodeTable32(asciicode::String, pad::Char; casesensitive::Bool=false)

Create a code table for base32.
"""
function CodeTable32(asciicode::String, pad::Char; casesensitive::Bool=false)
    if !isascii(asciicode) || !isascii(pad)
        throw(ArgumentError("the code table must be ASCII"))
    elseif length(asciicode) != 32
        throw(ArgumentError("the code size must be 32"))
    end
    encodeword = Vector{UInt8}(undef, 32)
    decodeword = Vector{UInt8}(undef, 128)
    fill!(decodeword, BASE32_CODEERR)
    for (i, char) in enumerate(asciicode)
        bits = UInt8(i-1)
        code = UInt8(char)
        encodeword[bits+1] = code
        decodeword[code+1] = bits
        if !casesensitive
            if isuppercase(char)
                code = UInt8(lowercase(char))
                decodeword[code+1] = bits
            end
            if islowercase(char)
                code = UInt8(uppercase(char))
                decodeword[code+1] = bits
            end
        end
    end
    padcode = UInt8(pad)
    decodeword[padcode+1] = BASE32_CODEPAD
    return CodeTable32(encodeword, decodeword, padcode)
end

@inline function encode(table::CodeTable32, byte::UInt8)
    return table.encodeword[Int(byte & 0x1f) + 1]
end

@inline function decode(table::CodeTable32, byte::UInt8)
    return table.decodeword[Int(byte)+1]
end

"""
The standard base32 code table (cf. Table 3 of RFC4648).
"""
const BASE32_STD = CodeTable32("ABCDEFGHIJKLMNOPQRSTUVWXYZ234567", '=')

"""
The extended hex code table (cf. Table 4 of RFC4648).
"""
const BASE32_HEX = CodeTable32("0123456789ABCDEFGHIJKLMNOPQRSTUV", '=')

# CodeTable64
# ===========

const CodeTable64 = CodeTable{64}

const BASE64_CODEPAD = 0x40  # PADding
const BASE64_CODEIGN = 0x41  # IGNore
const BASE64_CODEEND = 0x42  # END
const BASE64_CODEERR = 0xff  # ERRor

ignorecode(::Type{CodeTable64}) = BASE64_CODEIGN

"""
    CodeTable64(asciicode::String, pad::Char)

Create a code table for base64.
"""
function CodeTable64(asciicode::String, pad::Char)
    if !isascii(asciicode) || !isascii(pad)
        throw(ArgumentError("the code table must be ASCII"))
    elseif length(asciicode) != 64
        throw(ArgumentError("the code size must be 64"))
    end
    encodeword = Vector{UInt8}(undef, 64)
    decodeword = Vector{UInt8}(undef, 256)
    fill!(decodeword, BASE64_CODEERR)
    for (i, char) in enumerate(asciicode)
        bits = UInt8(i-1)
        code = UInt8(char)
        encodeword[bits+1] = code
        decodeword[code+1] = bits
    end
    padcode = UInt8(pad)
    decodeword[padcode+1] = BASE64_CODEPAD
    return CodeTable64(encodeword, decodeword, padcode)
end

@inline function encode(table::CodeTable64, byte::UInt8)
    return table.encodeword[Int(byte & 0x3f) + 1]
end

@inline function decode(table::CodeTable64, byte::UInt8)
    return table.decodeword[Int(byte)+1]
end

"""
The standard base64 code table (cf. Table 1 of RFC4648).
"""
const BASE64_STD = CodeTable64(
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", '=')

"""
The url-safe base64 code table (cf. Table 2 of RFC4648).
"""
const BASE64_URLSAFE = CodeTable64(
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_", '=')
